from Enums import *

# PHENOTYPE CLASS
class Phenotype:
    def __init__(self):
        self.data = []              # All effects gathered as one bitstring in correct order
        self.parameters = []        # Containing effect parameters as floating point values, order corresponding with the order list (self.order)
        self.order = []             # Order of the effects (Integer values corresponding to values in Enums.effects)
        self.fitness = 999.99

    def printInfo(self):
        res = "\nPhenotype info:"
        tempParameters = list(self.parameters)
        for i in range(len(self.order)):
            if self.order[i] == Enums.DISTORTION:
                res += "\nDistortion: "
                res += str(tempParameters[0])
                del tempParameters[0]
            if self.order[i] == Enums.FLANGER:
                res += "\nFlanger: "
                res += str(tempParameters[0])
                del tempParameters[0]
            if self.order[i] == Enums.TREMOLO:
                res += "\nTremolo: "
                res += str(tempParameters[0])
                res += ","
                res += str(tempParameters[1])
                del tempParameters[0]
                del tempParameters[0]
            if self.order[i] == Enums.CHORUS:
                res += "\nChorus: "
                res += str(tempParameters[0])
                res += ","
                res += str(tempParameters[1])
                del tempParameters[0]
                del tempParameters[0]
        res += "\nFitness: "
        res += str(self.fitness)
        res += "\n"
        print res

    def printOrder(self):
        res = "Order: "
        for i in range(len(self.order)):
            if self.order[i] == Enums.DISTORTION:
                res += "Distortion "
            if self.order[i] == Enums.FLANGER:
                res += "Flanger "
            if self.order[i] == Enums.TREMOLO:
                res += "Tremolo "
            if self.order[i] == Enums.CHORUS:
                res += "Chorus "
        return res

